-- named POSIX pipe interface module
-- load with require "gtk-server" ("fifo", pipename)
-- pipename defaults to a tmpname(), and is unlinked and recreated before use

return function(table, fifo)
	fifo = fifo or os.tmpname()
	
	os.remove(fifo)
	os.execute("gtk-server fifo="..fifo.." &")
	os.execute("sleep 1")

	table.pipename = fifo

	return function(message)
		local fout,fin,buf
		TRACE("SEND", message)
		fout = io.open(fifo, "w")
		fout:write(message)
		fout:close()

		fin = io.open(fifo, "r")
		buf = fin:read('*l')
		fin:close()
		TRACE("RECV", buf)
		return buf
	end
end
