/*  gtk-server interface module for direct library calls. This is the preferred
	interface, whenever possible.
	load me with require "gtk-server" ("library")
*/

#include <lua.h>
#include <lauxlib.h>

/* The function exported by libgtk-server */
extern const char * gtk(const char * arg);

/* our wrapper around it */
static int lua_gtk(lua_State * L)
{
	const char * message = luaL_checkstring(L, 1);
	const char * reply = gtk(message);
	lua_pushstring(L, reply);
	return 1;
}

/* we are expected to return an initializer that, in turn, will return
   a sender. This is our initializer - we aren't configurable, so all
   it does is return the sender function. */
static int lua_gtk_init(lua_State * L)
{
	lua_pushcfunction(L, lua_gtk);
	return 1;
}

/* This is the actual entry point. require() maps gtk-server.library to
	server_library, hence the name */
int luaopen_server_library(lua_State * L)
{
	lua_pushcfunction(L, lua_gtk_init);
	return 1;
}

