-- UDP socket module
-- load with require "gtk-server" ("udp", host, port, max_clients)
-- host defaults to localhost, port to a random port in the userspace range,
-- and max to 1

require "socket"

return function(table, host, port, max)
	host = host or "localhost"
	port = port or math.random(1025,65535)
	max = max or 1
	
	os.execute("gtk-server udp="..host..":"..port..":"..max.." &")
	os.execute("sleep 1")

	local sock = socket.udp()
	sock:setpeername(host, port)

	table.sock = sock
	table.host = host
	table.port = port

	return function(message)
		local buf
		sock:send(message)
		
		buf = sock:receive('*l')
		return buf
	end
end
